All of lore.kernel.org
 help / color / mirror / Atom feed
From: "Darrick J. Wong" <djwong@kernel.org>
To: zlang@redhat.com, djwong@kernel.org
Cc: Allison Henderson <allison.henderson@oracle.com>,
	Catherine Hoang <catherine.hoang@oracle.com>,
	fstests@vger.kernel.org, catherine.hoang@oracle.com,
	allison.henderson@oracle.com, guan@eryu.me,
	linux-xfs@vger.kernel.org
Subject: [PATCH 08/11] common: add helpers for parent pointer tests
Date: Sun, 31 Dec 2023 16:48:20 +9900	[thread overview]
Message-ID: <170405028533.1824869.17064208176068833295.stgit@frogsfrogsfrogs> (raw)
In-Reply-To: <170405028421.1824869.17871351204326094851.stgit@frogsfrogsfrogs>

From: Allison Henderson <allison.henderson@oracle.com>

Add helper functions in common/parent to parse and verify parent
pointers. Also add functions to check that mkfs, kernel, and xfs_io
support parent pointers.

Signed-off-by: Allison Henderson <allison.henderson@oracle.com>
Signed-off-by: Catherine Hoang <catherine.hoang@oracle.com>
Reviewed-by: Darrick J. Wong <djwong@kernel.org>
[djwong: add license and copyright, dont _fail tests immediately, make
 sure the pptr-generated paths match the dir-generated paths]
Signed-off-by: Darrick J. Wong <djwong@kernel.org>
---
 common/parent |  209 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 common/rc     |    3 +
 common/xfs    |   12 +++
 3 files changed, 224 insertions(+)
 create mode 100644 common/parent


diff --git a/common/parent b/common/parent
new file mode 100644
index 0000000000..3f7ac4ca35
--- /dev/null
+++ b/common/parent
@@ -0,0 +1,209 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2022-2024 Oracle and/or its affiliates.  All Rights Reserved.
+#
+# Parent pointer common functions
+#
+
+#
+# parse_parent_pointer parents parent_inode parent_pointer_name
+#
+# Given a list of parent pointers, find the record that matches
+# the given inode and filename
+#
+# inputs:
+# parents	: A list of parent pointers in the format of:
+#		  inode/generation/name_length/name
+# parent_inode	: The parent inode to search for
+# parent_name	: The parent name to search for
+#
+# outputs:
+# PPINO         : Parent pointer inode
+# PPGEN         : Parent pointer generation
+# PPNAME        : Parent pointer name
+# PPNAME_LEN    : Parent pointer name length
+#
+_parse_parent_pointer()
+{
+	local parents=$1
+	local pino=$2
+	local parent_pointer_name=$3
+
+	local found=0
+
+	# Find the entry that has the same inode as the parent
+	# and parse out the entry info
+	while IFS=\/ read PPINO PPGEN PPNAME_LEN PPNAME; do
+		if [ "$PPINO" != "$pino" ]; then
+			continue
+		fi
+
+		if [ "$PPNAME" != "$parent_pointer_name" ]; then
+			continue
+		fi
+
+		found=1
+		break
+	done <<< $(echo "$parents")
+
+	# Check to see if we found anything
+	# We do not fail the test because we also use this
+	# routine to verify when parent pointers should
+	# be removed or updated  (ie a rename or a move
+	# operation changes your parent pointer)
+	if [ $found -eq "0" ]; then
+		return 1
+	fi
+
+	# Verify the parent pointer name length is correct
+	if [ "$PPNAME_LEN" -ne "${#parent_pointer_name}" ]
+	then
+		echo "*** Bad parent pointer:"\
+			"name:$PPNAME, namelen:$PPNAME_LEN"
+	fi
+
+	#return sucess
+	return 0
+}
+
+#
+# _verify_parent parent_path parent_pointer_name child_path
+#
+# Verify that the given child path lists the given parent as a parent pointer
+# and that the parent pointer name matches the given name
+#
+# Examples:
+#
+# #simple example
+# mkdir testfolder1
+# touch testfolder1/file1
+# verify_parent testfolder1 file1 testfolder1/file1
+#
+# # In this above example, we want to verify that "testfolder1"
+# # appears as a parent pointer of "testfolder1/file1".  Additionally
+# # we verify that the name record of the parent pointer is "file1"
+#
+#
+# #hardlink example
+# mkdir testfolder1
+# mkdir testfolder2
+# touch testfolder1/file1
+# ln testfolder1/file1 testfolder2/file1_ln
+# verify_parent testfolder2 file1_ln testfolder1/file1
+#
+# # In this above example, we want to verify that "testfolder2"
+# # appears as a parent pointer of "testfolder1/file1".  Additionally
+# # we verify that the name record of the parent pointer is "file1_ln"
+#
+_verify_parent()
+{
+	local parent_path=$1
+	local parent_pointer_name=$2
+	local child_path=$3
+
+	local parent_ppath="$parent_path/$parent_pointer_name"
+
+	# Verify parent exists
+	if [ ! -d $SCRATCH_MNT/$parent_path ]; then
+		echo "$SCRATCH_MNT/$parent_path not found"
+	else
+		echo "*** $parent_path OK"
+	fi
+
+	# Verify child exists
+	if [ ! -f $SCRATCH_MNT/$child_path ]; then
+		echo "$SCRATCH_MNT/$child_path not found"
+	else
+		echo "*** $child_path OK"
+	fi
+
+	# Verify the parent pointer name exists as a child of the parent
+	if [ ! -f $SCRATCH_MNT/$parent_ppath ]; then
+		echo "$SCRATCH_MNT/$parent_ppath not found"
+	else
+		echo "*** $parent_ppath OK"
+	fi
+
+	# Get the inodes of both parent and child
+	pino="$(stat -c '%i' $SCRATCH_MNT/$parent_path)"
+	cino="$(stat -c '%i' $SCRATCH_MNT/$child_path)"
+
+	# Get all the parent pointers of the child
+	parents=($($XFS_IO_PROG -x -c \
+	 "parent -f -i $pino -n $parent_pointer_name" $SCRATCH_MNT/$child_path))
+	if [[ $? != 0 ]]; then
+		 echo "No parent pointers found for $child_path"
+	fi
+
+	# Parse parent pointer output.
+	# This sets PPINO PPGEN PPNAME PPNAME_LEN
+	_parse_parent_pointer $parents $pino $parent_pointer_name
+
+	# If we didnt find one, bail out
+	if [ $? -ne 0 ]; then
+		echo "No parent pointer record found for $parent_path"\
+			"in $child_path"
+	fi
+
+	# Verify the inode generated by the parent pointer name is
+	# the same as the child inode
+	pppino="$(stat -c '%i' $SCRATCH_MNT/$parent_ppath)"
+	if [ $cino -ne $pppino ]
+	then
+		echo "Bad parent pointer name value for $child_path."\
+			"$SCRATCH_MNT/$parent_ppath belongs to inode $PPPINO,"\
+			"but should be $cino"
+	fi
+
+	# Make sure path printing works by checking that the paths returned
+	# all point to the same inode.
+	local tgt="$SCRATCH_MNT/$child_path"
+	$XFS_IO_PROG -x -c 'parent -p' "$tgt" | while read pptr_path; do
+		test "$tgt" -ef "$pptr_path" || \
+			echo "$tgt parent pointer $pptr_path should be the same file"
+	done
+
+	echo "*** Verified parent pointer:"\
+			"name:$PPNAME, namelen:$PPNAME_LEN"
+	echo "*** Parent pointer OK for child $child_path"
+}
+
+#
+# _verify_parent parent_pointer_name pino child_path
+#
+# Verify that the given child path contains no parent pointer entry
+# for the given inode and file name
+#
+_verify_no_parent()
+{
+	local parent_pname=$1
+	local pino=$2
+	local child_path=$3
+
+	# Verify child exists
+	if [ ! -f $SCRATCH_MNT/$child_path ]; then
+		echo "$SCRATCH_MNT/$child_path not found"
+	else
+		echo "*** $child_path OK"
+	fi
+
+	# Get all the parent pointers of the child
+	local parents=($($XFS_IO_PROG -x -c \
+	 "parent -f -i $pino -n $parent_pname" $SCRATCH_MNT/$child_path))
+	if [[ $? != 0 ]]; then
+		return 0
+	fi
+
+	# Parse parent pointer output.
+	# This sets PPINO PPGEN PPNAME PPNAME_LEN
+	_parse_parent_pointer $parents $pino $parent_pname
+
+	# If we didnt find one, return sucess
+	if [ $? -ne 0 ]; then
+		return 0
+	fi
+
+	echo "Parent pointer entry found where none should:"\
+			"inode:$PPINO, gen:$PPGEN,"
+			"name:$PPNAME, namelen:$PPNAME_LEN"
+}
diff --git a/common/rc b/common/rc
index 0898ac08eb..f760eedc26 100644
--- a/common/rc
+++ b/common/rc
@@ -2656,6 +2656,9 @@ _require_xfs_io_command()
 		echo $testio | grep -q "invalid option" && \
 			_notrun "xfs_io $command support is missing"
 		;;
+	"parent")
+		testio=`$XFS_IO_PROG -x -c "parent" $TEST_DIR 2>&1`
+		;;
 	"pwrite")
 		# -N (RWF_NOWAIT) only works with direct vectored I/O writes
 		local pwrite_opts=" "
diff --git a/common/xfs b/common/xfs
index 88fa6fb55a..f77d4639b9 100644
--- a/common/xfs
+++ b/common/xfs
@@ -1831,3 +1831,15 @@ _xfs_force_no_pptrs()
 
 	MKFS_OPTIONS="$MKFS_OPTIONS -n parent=0"
 }
+
+# this test requires the xfs parent pointers feature
+#
+_require_xfs_parent()
+{
+	_scratch_mkfs_xfs_supported -n parent > /dev/null 2>&1 \
+		|| _notrun "mkfs.xfs does not support parent pointers"
+	_scratch_mkfs_xfs -n parent > /dev/null 2>&1
+	_try_scratch_mount >/dev/null 2>&1 \
+		|| _notrun "kernel does not support parent pointers"
+	_scratch_unmount
+}


  parent reply	other threads:[~2024-01-01  0:48 UTC|newest]

Thread overview: 187+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2023-12-31 18:18 [NYE PATCHRIVER 2/4] xfs: online repair part 2 Darrick J. Wong
2023-12-31 19:32 ` [PATCHSET v13.0 1/7] xfs: design documentation for online fsck, " Darrick J. Wong
2023-12-31 20:42   ` [PATCH 1/4] docs: update the parent pointers documentation to the final version Darrick J. Wong
2023-12-31 20:42   ` [PATCH 2/4] docs: update online directory and parent pointer repair sections Darrick J. Wong
2023-12-31 20:42   ` [PATCH 3/4] docs: update offline parent pointer repair strategy Darrick J. Wong
2023-12-31 20:43   ` [PATCH 4/4] docs: describe xfs directory tree online fsck Darrick J. Wong
2023-12-31 19:33 ` [PATCHSET v13.0 2/7] xfs: retain ILOCK during directory updates Darrick J. Wong
2023-12-31 20:43   ` [PATCH 1/7] xfs: Increase XFS_DEFER_OPS_NR_INODES to 5 Darrick J. Wong
2023-12-31 20:43   ` [PATCH 2/7] xfs: Increase XFS_QM_TRANS_MAXDQS " Darrick J. Wong
2023-12-31 20:43   ` [PATCH 3/7] xfs: Hold inode locks in xfs_ialloc Darrick J. Wong
2023-12-31 20:44   ` [PATCH 4/7] xfs: Hold inode locks in xfs_trans_alloc_dir Darrick J. Wong
2023-12-31 20:44   ` [PATCH 5/7] xfs: Hold inode locks in xfs_rename Darrick J. Wong
2023-12-31 20:44   ` [PATCH 6/7] xfs: don't pick up IOLOCK during rmapbt repair scan Darrick J. Wong
2023-12-31 20:44   ` [PATCH 7/7] xfs: unlock new repair tempfiles after creation Darrick J. Wong
2023-12-31 19:33 ` [PATCHSET v13.0 3/7] xfs: name-value xattr lookups Darrick J. Wong
2023-12-31 20:45   ` [PATCH 01/14] xfs: require XFS_SB_FEAT_INCOMPAT_LOG_XATTRS for attr log intent item recovery Darrick J. Wong
2023-12-31 20:45   ` [PATCH 02/14] xfs: allow newer INCOMPAT/RO_COMPAT feature bits to protect ATTRI log items Darrick J. Wong
2023-12-31 20:45   ` [PATCH 03/14] xfs: check opcode and iovec count match in xlog_recover_attri_commit_pass2 Darrick J. Wong
2023-12-31 20:45   ` [PATCH 04/14] xfs: make xfs_attr_set require XFS_DA_OP_REMOVE Darrick J. Wong
2023-12-31 20:46   ` [PATCH 05/14] xfs: allow xattr matching on name and value for local/sf attrs Darrick J. Wong
2023-12-31 20:46   ` [PATCH 06/14] xfs: preserve NVLOOKUP in xfs_attr_set Darrick J. Wong
2023-12-31 20:46   ` [PATCH 07/14] xfs: restructure xfs_attr_complete_op a bit Darrick J. Wong
2023-12-31 20:46   ` [PATCH 08/14] xfs: use helpers to extract xattr op from opflags Darrick J. Wong
2023-12-31 20:47   ` [PATCH 09/14] xfs: validate recovered name buffers when recovering xattr items Darrick J. Wong
2023-12-31 20:47   ` [PATCH 10/14] xfs: always set args->value in xfs_attri_item_recover Darrick J. Wong
2023-12-31 20:47   ` [PATCH 11/14] xfs: use local variables for name and value length in _attri_commit_pass2 Darrick J. Wong
2023-12-31 20:47   ` [PATCH 12/14] xfs: log NVLOOKUP xattr removal operations Darrick J. Wong
2023-12-31 20:48   ` [PATCH 13/14] xfs: log NVLOOKUP xattr setting operations Darrick J. Wong
2023-12-31 20:48   ` [PATCH 14/14] xfs: log NVLOOKUP xattr nvreplace operations Darrick J. Wong
2023-12-31 19:33 ` [PATCHSET v13.0 4/7] xfs: Parent Pointers Darrick J. Wong
2023-12-31 20:48   ` [PATCH 01/18] xfs: Expose init_xattrs in xfs_create_tmpfile Darrick J. Wong
2023-12-31 20:49   ` [PATCH 02/18] xfs: add parent pointer support to attribute code Darrick J. Wong
2023-12-31 20:49   ` [PATCH 03/18] xfs: define parent pointer ondisk extended attribute format Darrick J. Wong
2023-12-31 20:49   ` [PATCH 04/18] xfs: add parent pointer validator functions Darrick J. Wong
2023-12-31 20:49   ` [PATCH 05/18] xfs: extend transaction reservations for parent attributes Darrick J. Wong
2023-12-31 20:50   ` [PATCH 06/18] xfs: parent pointer attribute creation Darrick J. Wong
2023-12-31 20:50   ` [PATCH 07/18] xfs: add parent attributes to link Darrick J. Wong
2023-12-31 20:50   ` [PATCH 08/18] xfs: add parent attributes to symlink Darrick J. Wong
2023-12-31 20:50   ` [PATCH 09/18] xfs: remove parent pointers in unlink Darrick J. Wong
2023-12-31 20:51   ` [PATCH 10/18] xfs: Add parent pointers to rename Darrick J. Wong
2023-12-31 20:51   ` [PATCH 11/18] xfs: Add parent pointers to xfs_cross_rename Darrick J. Wong
2023-12-31 20:51   ` [PATCH 12/18] xfs: Filter XFS_ATTR_PARENT for getfattr Darrick J. Wong
2023-12-31 20:51   ` [PATCH 13/18] xfs: pass the attr value to put_listent when possible Darrick J. Wong
2023-12-31 20:52   ` [PATCH 14/18] xfs: Add parent pointer ioctl Darrick J. Wong
2023-12-31 20:52   ` [PATCH 15/18] xfs: fix unit conversion error in xfs_log_calc_max_attrsetm_res Darrick J. Wong
2023-12-31 20:52   ` [PATCH 16/18] xfs: drop compatibility minimum log size computations for reflink Darrick J. Wong
2023-12-31 20:52   ` [PATCH 17/18] xfs: don't remove the attr fork when parent pointers are enabled Darrick J. Wong
2023-12-31 20:53   ` [PATCH 18/18] xfs: Add the parent pointer support to the superblock version 5 Darrick J. Wong
2023-12-31 19:33 ` [PATCHSET v13.0 5/7] xfs: fsck for parent pointers Darrick J. Wong
2023-12-31 20:53   ` [PATCH 01/22] xfs: check dirents have " Darrick J. Wong
2023-12-31 20:53   ` [PATCH 02/22] xfs: deferred scrub of dirents Darrick J. Wong
2023-12-31 20:53   ` [PATCH 03/22] xfs: create a parent pointer walk function for scrubbers Darrick J. Wong
2023-12-31 20:54   ` [PATCH 04/22] xfs: scrub parent pointers Darrick J. Wong
2023-12-31 20:54   ` [PATCH 05/22] xfs: deferred scrub of " Darrick J. Wong
2023-12-31 20:54   ` [PATCH 06/22] xfs: walk directory parent pointers to determine backref count Darrick J. Wong
2023-12-31 20:55   ` [PATCH 07/22] xfs: add raw parent pointer apis to support repair Darrick J. Wong
2023-12-31 20:55   ` [PATCH 08/22] xfs: set child file owner in xfs_da_args when changing parent pointers Darrick J. Wong
2023-12-31 20:55   ` [PATCH 09/22] xfs: salvage parent pointers when rebuilding xattr structures Darrick J. Wong
2023-12-31 20:55   ` [PATCH 10/22] xfs: replace namebuf with parent pointer in directory repair Darrick J. Wong
2023-12-31 20:56   ` [PATCH 11/22] xfs: repair directories by scanning directory parent pointers Darrick J. Wong
2023-12-31 20:56   ` [PATCH 12/22] xfs: implement live updates for directory repairs Darrick J. Wong
2023-12-31 20:56   ` [PATCH 13/22] xfs: replay unlocked parent pointer updates that accrue during xattr repair Darrick J. Wong
2023-12-31 20:56   ` [PATCH 14/22] xfs: replace namebuf with parent pointer in parent pointer repair Darrick J. Wong
2023-12-31 20:57   ` [PATCH 15/22] xfs: repair directory parent pointers by scanning for dirents Darrick J. Wong
2023-12-31 20:57   ` [PATCH 16/22] xfs: implement live updates for parent pointer repairs Darrick J. Wong
2023-12-31 20:57   ` [PATCH 17/22] xfs: remove pointless unlocked assertion Darrick J. Wong
2023-12-31 20:57   ` [PATCH 18/22] xfs: split xfs_bmap_add_attrfork into two pieces Darrick J. Wong
2023-12-31 20:58   ` [PATCH 19/22] xfs: actually rebuild the parent pointer xattrs Darrick J. Wong
2023-12-31 20:58   ` [PATCH 20/22] xfs: adapt the orphanage code to handle parent pointers Darrick J. Wong
2023-12-31 20:58   ` [PATCH 21/22] xfs: repair link count of nondirectories after rebuilding " Darrick J. Wong
2023-12-31 20:58   ` [PATCH 22/22] xfs: inode repair should ensure there's an attr fork to store " Darrick J. Wong
2023-12-31 19:34 ` [PATCHSET v13.0 6/7] xfs: detect and correct directory tree problems Darrick J. Wong
2023-12-31 20:59   ` [PATCH 1/4] xfs: teach online scrub to find directory tree structure problems Darrick J. Wong
2023-12-31 20:59   ` [PATCH 2/4] xfs: invalidate dirloop scrub path data when concurrent updates happen Darrick J. Wong
2023-12-31 20:59   ` [PATCH 3/4] xfs: report directory tree corruption in the health information Darrick J. Wong
2023-12-31 20:59   ` [PATCH 4/4] xfs: fix corruptions in the directory tree Darrick J. Wong
2023-12-31 19:34 ` [PATCHSET v13.0 7/7] xfs: vectorize scrub kernel calls Darrick J. Wong
2023-12-31 21:00   ` [PATCH 1/3] xfs: reduce the rate of cond_resched calls inside scrub Darrick J. Wong
2023-12-31 21:00   ` [PATCH 2/3] xfs: introduce vectored scrub mode Darrick J. Wong
2023-12-31 21:00   ` [PATCH 3/3] xfs: only iget the file once when doing vectored scrub-by-handle Darrick J. Wong
2023-12-31 19:50 ` [PATCHSET v13.0 1/6] xfsprogs: retain ILOCK during directory updates Darrick J. Wong
2023-12-31 23:02   ` [PATCH 1/1] xfs: Increase XFS_DEFER_OPS_NR_INODES to 5 Darrick J. Wong
2023-12-31 19:50 ` [PATCHSET v13.0 2/6] xfsprogs: name-value xattr lookups Darrick J. Wong
2023-12-31 23:02   ` [PATCH 01/11] xfs: allow newer INCOMPAT/RO_COMPAT feature bits to protect ATTRI log items Darrick J. Wong
2023-12-31 23:02   ` [PATCH 02/11] xfs: make xfs_attr_set require XFS_DA_OP_REMOVE Darrick J. Wong
2023-12-31 23:03   ` [PATCH 03/11] xfs: allow xattr matching on name and value for local/sf attrs Darrick J. Wong
2023-12-31 23:03   ` [PATCH 04/11] xfs: preserve NVLOOKUP in xfs_attr_set Darrick J. Wong
2023-12-31 23:03   ` [PATCH 05/11] xfs: restructure xfs_attr_complete_op a bit Darrick J. Wong
2023-12-31 23:03   ` [PATCH 06/11] xfs: use helpers to extract xattr op from opflags Darrick J. Wong
2023-12-31 23:04   ` [PATCH 07/11] xfs: log NVLOOKUP xattr removal operations Darrick J. Wong
2023-12-31 23:04   ` [PATCH 08/11] xfs: log NVLOOKUP xattr setting operations Darrick J. Wong
2023-12-31 23:04   ` [PATCH 09/11] xfs: log NVLOOKUP xattr nvreplace operations Darrick J. Wong
2023-12-31 23:04   ` [PATCH 10/11] xfs_logprint: dump new attr log item fields Darrick J. Wong
2023-12-31 23:05   ` [PATCH 11/11] xfs_logprint: print missing attri header fields Darrick J. Wong
2023-12-31 19:50 ` [PATCHSET v13.0 3/6] xfsprogs: Parent Pointers Darrick J. Wong
2023-12-31 23:05   ` [PATCH 01/32] xfs: add parent pointer support to attribute code Darrick J. Wong
2023-12-31 23:05   ` [PATCH 02/32] xfs: define parent pointer ondisk extended attribute format Darrick J. Wong
2023-12-31 23:05   ` [PATCH 03/32] xfs: add parent pointer validator functions Darrick J. Wong
2023-12-31 23:06   ` [PATCH 04/32] xfs: extend transaction reservations for parent attributes Darrick J. Wong
2023-12-31 23:06   ` [PATCH 05/32] xfs: parent pointer attribute creation Darrick J. Wong
2023-12-31 23:06   ` [PATCH 06/32] xfs: add parent attributes to link Darrick J. Wong
2023-12-31 23:06   ` [PATCH 07/32] xfs: add parent attributes to symlink Darrick J. Wong
2023-12-31 23:07   ` [PATCH 08/32] xfs: remove parent pointers in unlink Darrick J. Wong
2023-12-31 23:07   ` [PATCH 09/32] xfs: Add parent pointers to rename Darrick J. Wong
2023-12-31 23:07   ` [PATCH 10/32] xfs: pass the attr value to put_listent when possible Darrick J. Wong
2023-12-31 23:07   ` [PATCH 11/32] xfs: Add parent pointer ioctl Darrick J. Wong
2023-12-31 23:08   ` [PATCH 12/32] xfs: fix unit conversion error in xfs_log_calc_max_attrsetm_res Darrick J. Wong
2023-12-31 23:08   ` [PATCH 13/32] xfs: drop compatibility minimum log size computations for reflink Darrick J. Wong
2023-12-31 23:08   ` [PATCH 14/32] xfs: don't remove the attr fork when parent pointers are enabled Darrick J. Wong
2023-12-31 23:09   ` [PATCH 15/32] xfs: Add the parent pointer support to the superblock version 5 Darrick J. Wong
2023-12-31 23:09   ` [PATCH 16/32] libfrog: add parent pointer support code Darrick J. Wong
2023-12-31 23:09   ` [PATCH 17/32] libfrog: detect looping paths when walking directory parent pointers Darrick J. Wong
2023-12-31 23:09   ` [PATCH 18/32] xfs_io: adapt parent command to new parent pointer ioctls Darrick J. Wong
2023-12-31 23:10   ` [PATCH 19/32] xfs_io: Add i, n and f flags to parent command Darrick J. Wong
2023-12-31 23:10   ` [PATCH 20/32] xfs_logprint: decode parent pointers in ATTRI items fully Darrick J. Wong
2023-12-31 23:10   ` [PATCH 21/32] xfs_spaceman: report file paths Darrick J. Wong
2023-12-31 23:10   ` [PATCH 22/32] xfs_scrub: use parent pointers when possible to report file operations Darrick J. Wong
2023-12-31 23:11   ` [PATCH 23/32] xfs_db: report parent pointers in version command Darrick J. Wong
2023-12-31 23:11   ` [PATCH 24/32] xfs_db: report parent bit on xattrs Darrick J. Wong
2023-12-31 23:11   ` [PATCH 25/32] xfs_db: report parent pointers embedded in xattrs Darrick J. Wong
2023-12-31 23:11   ` [PATCH 26/32] xfs_db: obfuscate dirent and parent pointer names consistently Darrick J. Wong
2023-12-31 23:12   ` [PATCH 27/32] libxfs: export attr3_leaf_hdr_from_disk via libxfs_api_defs.h Darrick J. Wong
2023-12-31 23:12   ` [PATCH 28/32] xfs_db: add a parents command to list the parents of a file Darrick J. Wong
2023-12-31 23:12   ` [PATCH 29/32] libxfs: create new files with attr forks if necessary Darrick J. Wong
2023-12-31 23:12   ` [PATCH 30/32] xfsprogs: Fix default superblock attr bits Darrick J. Wong
2023-12-31 23:13   ` [PATCH 31/32] mkfs: Add parent pointers during protofile creation Darrick J. Wong
2023-12-31 23:13   ` [PATCH 32/32] mkfs: enable formatting with parent pointers Darrick J. Wong
2023-12-31 19:51 ` [PATCHSET v13.0 4/6] xfsprogs: fsck for " Darrick J. Wong
2023-12-31 23:13   ` [PATCH 01/18] xfs: create a blob array data structure Darrick J. Wong
2023-12-31 23:13   ` [PATCH 02/18] xfs: check dirents have parent pointers Darrick J. Wong
2023-12-31 23:14   ` [PATCH 03/18] man2: update ioctl_xfs_scrub_metadata.2 for " Darrick J. Wong
2023-12-31 23:14   ` [PATCH 04/18] xfs: add raw parent pointer apis to support repair Darrick J. Wong
2023-12-31 23:14   ` [PATCH 05/18] xfs: set child file owner in xfs_da_args when changing parent pointers Darrick J. Wong
2023-12-31 23:15   ` [PATCH 06/18] xfs: remove pointless unlocked assertion Darrick J. Wong
2023-12-31 23:15   ` [PATCH 07/18] xfs: split xfs_bmap_add_attrfork into two pieces Darrick J. Wong
2023-12-31 23:15   ` [PATCH 08/18] xfs: actually rebuild the parent pointer xattrs Darrick J. Wong
2023-12-31 23:15   ` [PATCH 09/18] xfs_repair: add parent pointers when messing with /lost+found Darrick J. Wong
2023-12-31 23:16   ` [PATCH 10/18] xfs_repair: build a parent pointer index Darrick J. Wong
2023-12-31 23:16   ` [PATCH 11/18] xfs_repair: move the global dirent name store to a separate object Darrick J. Wong
2023-12-31 23:16   ` [PATCH 12/18] xfs_repair: deduplicate strings stored in string blob Darrick J. Wong
2023-12-31 23:16   ` [PATCH 13/18] xfs_repair: check parent pointers Darrick J. Wong
2023-12-31 23:17   ` [PATCH 14/18] xfs_repair: dump garbage parent pointer attributes Darrick J. Wong
2023-12-31 23:17   ` [PATCH 15/18] xfs_repair: update ondisk parent pointer records Darrick J. Wong
2023-12-31 23:17   ` [PATCH 16/18] xfs_repair: wipe ondisk parent pointers when there are none Darrick J. Wong
2023-12-31 23:17   ` [PATCH 17/18] xfs_repair: upgrade an existing filesystem to have parent pointers Darrick J. Wong
2023-12-31 23:18   ` [PATCH 18/18] xfs_scrub: use parent pointers to report lost file data Darrick J. Wong
2023-12-31 19:51 ` [PATCHSET v13.0 5/6] xfs: detect and correct directory tree problems Darrick J. Wong
2023-12-31 23:18   ` [PATCH 1/6] xfs_db: add link and unlink expert commands Darrick J. Wong
2023-12-31 23:18   ` [PATCH 2/6] xfs: teach online scrub to find directory tree structure problems Darrick J. Wong
2023-12-31 23:18   ` [PATCH 3/6] xfs: report directory tree corruption in the health information Darrick J. Wong
2023-12-31 23:19   ` [PATCH 4/6] xfs_scrub: fix erroring out of check_inode_names Darrick J. Wong
2023-12-31 23:19   ` [PATCH 5/6] xfs_scrub: detect and repair directory tree corruptions Darrick J. Wong
2023-12-31 23:19   ` [PATCH 6/6] xfs_scrub: defer phase5 file scans if dirloop fails Darrick J. Wong
2023-12-31 19:51 ` [PATCHSET 6/6] xfs_scrub: vectorize kernel calls Darrick J. Wong
2023-12-31 23:19   ` [PATCH 01/10] xfs: introduce vectored scrub mode Darrick J. Wong
2023-12-31 23:20   ` [PATCH 02/10] libfrog: support vectored scrub Darrick J. Wong
2023-12-31 23:20   ` [PATCH 03/10] xfs_io: " Darrick J. Wong
2023-12-31 23:20   ` [PATCH 04/10] xfs_scrub: split the scrub epilogue code into a separate function Darrick J. Wong
2023-12-31 23:21   ` [PATCH 05/10] xfs_scrub: split the repair " Darrick J. Wong
2023-12-31 23:21   ` [PATCH 06/10] xfs_scrub: convert scrub and repair epilogues to use xfs_scrub_vec Darrick J. Wong
2023-12-31 23:21   ` [PATCH 07/10] xfs_scrub: vectorize scrub calls Darrick J. Wong
2023-12-31 23:21   ` [PATCH 08/10] xfs_scrub: vectorize repair calls Darrick J. Wong
2023-12-31 23:22   ` [PATCH 09/10] xfs_scrub: use scrub barriers to reduce kernel calls Darrick J. Wong
2023-12-31 23:22   ` [PATCH 10/10] xfs_scrub: try spot repairs of metadata items to make scrub progress Darrick J. Wong
2023-12-31 19:59 ` [PATCHSET v13.0 1/3] fstests: adjust tests for xfs parent pointers Darrick J. Wong
2023-12-27 13:46   ` [PATCH 01/11] generic: test recovery of extended attribute updates Darrick J. Wong
2023-12-27 13:46   ` [PATCH 02/11] xfs/206: filter out the parent= status from mkfs Darrick J. Wong
2023-12-27 13:47   ` [PATCH 03/11] xfs/122: update for parent pointers Darrick J. Wong
2023-12-27 13:47   ` [PATCH 04/11] populate: create hardlinks " Darrick J. Wong
2023-12-27 13:47   ` [PATCH 05/11] xfs/021: adapt golden output files " Darrick J. Wong
2023-12-27 13:47   ` [PATCH 06/11] xfs/{018,191,288}: disable parent pointers for this test Darrick J. Wong
2023-12-27 13:48   ` [PATCH 07/11] xfs/306: fix formatting failures with parent pointers Darrick J. Wong
2023-12-27 13:48   ` Darrick J. Wong [this message]
2023-12-27 13:48   ` [PATCH 09/11] xfs: add parent pointer test Darrick J. Wong
2023-12-27 13:48   ` [PATCH 10/11] xfs: add multi link " Darrick J. Wong
2023-12-27 13:49   ` [PATCH 11/11] xfs: add parent pointer inject test Darrick J. Wong
2023-12-31 19:59 ` [PATCHSET v13.0 2/3] xfs: detect and correct directory tree structures Darrick J. Wong
2023-12-27 13:49   ` [PATCH 1/2] common/fuzzy: stress directory tree modifications with the dirtree tester Darrick J. Wong
2023-12-27 13:49   ` [PATCH 2/2] scrub: test correction of directory tree corruptions Darrick J. Wong
2023-12-31 19:59 ` [PATCHSET 3/3] xfs_scrub: vectorize kernel calls Darrick J. Wong
2023-12-27 13:49   ` [PATCH 1/1] xfs/122: update for vectored scrub Darrick J. Wong
2023-12-31 20:03 ` [PATCHSET v13.0 1/2] xfs-documentation: document attr log item changes for parent pointers Darrick J. Wong
2023-12-27 14:07   ` [PATCH 1/1] design: document new name-value logged attribute variants Darrick J. Wong
2023-12-31 20:03 ` [PATCHSET v13.0 2/2] xfs-documentation: document parent pointers Darrick J. Wong
2023-12-27 14:07   ` [PATCH 1/1] design: document the parent pointer ondisk format Darrick J. Wong
  -- strict thread matches above, loose matches on Subject: below --
2023-05-26  2:00 [PATCHSET RFC v12.0 00/11] fstests: adjust tests for xfs parent pointers Darrick J. Wong
2023-05-26  2:04 ` [PATCH 08/11] common: add helpers for parent pointer tests Darrick J. Wong
2023-04-06 19:16 [PATCHSET v11 00/11] fstests: adjust tests for xfs parent pointers Darrick J. Wong
2023-04-06 19:43 ` [PATCH 08/11] common: add helpers for parent pointer tests Darrick J. Wong

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=170405028533.1824869.17064208176068833295.stgit@frogsfrogsfrogs \
    --to=djwong@kernel.org \
    --cc=allison.henderson@oracle.com \
    --cc=catherine.hoang@oracle.com \
    --cc=fstests@vger.kernel.org \
    --cc=guan@eryu.me \
    --cc=linux-xfs@vger.kernel.org \
    --cc=zlang@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.